# WikiPublishTask

Extends \Task

Publish Wiki document using Wiki API.

Use \Project#createTask to register a new Task.

author | Piotr Lewandowski piotr@cassis.pl
package | phing.tasks.ext

### Methods

## Close curl connection and clean up

    __destruct()

## Call Wiki webapi

    callApi(string $queryString, array|null $postData = null) : array

throws |

### Arguments

#### $queryString

`string`

#### $postData

`array|null`

### Response

`array`

## Call Wiki webapi edit action

    callApiEdit()

## Call Wiki webapi login action

    callApiLogin(string|null $token = null)

throws |

### Arguments

#### $token

`string|null`

## Call Wiki webapi tokens action

    callApiTokens()

throws |

## Validate Wiki webapi response

    checkApiResponseResult(string $action, array $response, string $expect = 'Success')

throws |

### Arguments

#### $action

`string`

#### $response

`array`

#### $expect

`string`

## Return prepared data for Wiki webapi edit action

    getApiEditData() : array

### Response

`array`

## getApiPassword

    getApiPassword() : string

### Response

`string`

## getApiUrl

    getApiUrl() : string

### Response

`string`

## getApiUser

    getApiUser() : string

### Response

`string`

## getContent

    getContent() : string

### Response

`string`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getId

    getId() : integer

### Response

`integer`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## getMode

    getMode() : string

### Response

`string`

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## getTitle

    getTitle() : string

### Response

`string`

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## setApiPassword

    setApiPassword(string $apiPassword)

### Arguments

#### $apiPassword

`string`

## setApiUrl

    setApiUrl(string $apiUrl)

### Arguments

#### $apiUrl

`string`

## setApiUser

    setApiUser(string $apiUser)

### Arguments

#### $apiUser

`string`

## setContent

    setContent(string $content)

### Arguments

#### $content

`string`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setId

    setId(integer $id)

### Arguments

#### $id

`integer`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## setMode

    setMode(string $mode)

throws |

### Arguments

#### $mode

`string`

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Set POST data for curl call

    setPostData(array|null $data = null)

### Arguments

#### $data

`array|null`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## setTitle

    setTitle(string $title)

### Arguments

#### $title

`string`

## Validates attributes coming in from XML

    validateAttributes()

throws |

### Properties

## Wiki API url

    apiUrl : string

var |

### Type(s)

`string`

## Wiki API user name

    apiUser : string

var |

### Type(s)

`string`

## Wiki API password

    apiPassword : string

var |

### Type(s)

`string`

## Wiki document Id. Document can be identified by title instead.

    id : integer

var |

### Type(s)

`integer`

## Wiki document title

    title : string

var |

### Type(s)

`string`

## Wiki document content

    content : string

var |

### Type(s)

`string`

## Publishing mode (append, prepend, overwrite).

    mode : string

var |

### Type(s)

`string`

## Publish modes map

    modeMap : array

var |

### Type(s)

`array`

## Curl handler

    curl : resource

var |

### Type(s)

`resource`

## Wiki api edit token

    apiEditToken : string

var |

### Type(s)

`string`

## Temporary cookies file

    cookiesFile : string

var |

### Type(s)

`string`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`